﻿using OkstraI18NTranslation;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SchemaLevelTranslator
{
    class Program
    {
        static void Main(string[] args)
        {
            List<string> schemaFilenames = new List<string>();
            schemaFilenames.Add("Datentypen.xsd");
            schemaFilenames.Add("okstra-basis.xsd");
            schemaFilenames.Add("okstra-typen.xsd");
            schemaFilenames.Add("okstra.xsd");
            schemaFilenames.Add("Schluesseltabellen.xsd");
            schemaFilenames.Add("S_Administration.xsd");
            schemaFilenames.Add("S_Allgemeine_Geometrieobjekte.xsd");
            schemaFilenames.Add("S_Allgemeine_Mengenberechnung.xsd");
            schemaFilenames.Add("S_Allgemeine_Objekte.xsd");
            schemaFilenames.Add("S_Arbeitsstelle_an_Strassen.xsd");
            schemaFilenames.Add("S_Bauliche_Strasseneigenschaften.xsd");
            schemaFilenames.Add("S_Bauwerke.xsd");
            schemaFilenames.Add("S_Dynamische_Beschilderung.xsd");
            schemaFilenames.Add("S_Dynamische_Verkehrsdaten.xsd");
            schemaFilenames.Add("S_Entwurf.xsd");
            schemaFilenames.Add("S_Flaechenmodell.xsd");
            schemaFilenames.Add("S_Grunderwerb.xsd");
            schemaFilenames.Add("S_Hausnummern.xsd");
            schemaFilenames.Add("S_Historisierung.xsd");
            schemaFilenames.Add("S_Kataster.xsd");
            schemaFilenames.Add("S_Kostenmanagement.xsd");
            schemaFilenames.Add("S_Kreuzungen.xsd");
            schemaFilenames.Add("S_Landschaftsplanung.xsd");
            schemaFilenames.Add("S_Lichtsignalanlage.xsd");
            schemaFilenames.Add("S_Liegenschaftsverwaltung.xsd");
            schemaFilenames.Add("S_Netzaenderungsprotokoll.xsd");
            schemaFilenames.Add("S_Oekologie.xsd");
            schemaFilenames.Add("S_Organisation.xsd");
            schemaFilenames.Add("S_Projektressourcen.xsd");
            schemaFilenames.Add("S_REB_22013.xsd");
            schemaFilenames.Add("S_Schwertransport.xsd");
            schemaFilenames.Add("S_Statische_Beschilderung.xsd");
            schemaFilenames.Add("S_Strassenausstattungen.xsd");
            schemaFilenames.Add("S_Strassennetz.xsd");
            schemaFilenames.Add("S_Strassenverzeichnis.xsd");
            schemaFilenames.Add("S_Strassenzustandsdaten.xsd");
            schemaFilenames.Add("S_Topografie.xsd");
            schemaFilenames.Add("S_Umfeldmessstelle.xsd");
            schemaFilenames.Add("S_Unfall.xsd");
            schemaFilenames.Add("S_Verkehr.xsd");
            schemaFilenames.Add("S_Vermessungspunkt.xsd");

            foreach (var schemaName in schemaFilenames)
            {
                string filename = @"E:\dev\OkstraI18N\SchemaGerman\" + schemaName;

                System.Console.WriteLine("Reading " + filename);

                System.IO.StreamReader reader = new System.IO.StreamReader(filename, Encoding.GetEncoding("iso-8859-1"));

                List<TranslationSubstring> tsFilenames = new List<TranslationSubstring>();
                tsFilenames.Add(new TranslationSubstring("Datentypen.xsd", "Data_Types.xsd"));
                tsFilenames.Add(new TranslationSubstring("okstra-typen.xsd", "okstra-types.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Allgemeine_Geometrieobjekte.xsd", "S_General_Geometry_Objects.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Allgemeine_Mengenberechnung.xsd", "S_General_Quantity_Calculation.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Allgemeine_Objekte.xsd", "S_General_Objects.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Arbeitsstelle_an_Strassen.xsd", "S_Work_Place_On_Road.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Bauliche_Strasseneigenschaften.xsd", "S_Structural_Road_Properties.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Bauwerke.xsd", "S_Buildings.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Dynamische_Beschilderung.xsd", "S_Dynamic_Signage.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Dynamische_Verkehrsdaten.xsd", "S_Dynamic_Traffic_Data.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Entwurf.xsd", "S_Design.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Flaechenmodell.xsd", "S_Area_Model.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Grunderwerb.xsd", "S_Land_Acquisition.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Hausnummern.xsd", "S_House_Numbers.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Historisierung.xsd", "S_Historicisation.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Kataster.xsd", "S_Land_Register.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Kostenmanagement.xsd", "S_Cost_Management.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Kreuzungen.xsd", "S_Junctions.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Landschaftsplanung.xsd", "S_Landscape_Planning.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Lichtsignalanlage.xsd", "S_Traffic_Light_System.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Liegenschaftsverwaltung.xsd", "S_Property_Management.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Netzaenderungsprotokoll.xsd", "S_Net_Activity_Log.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Oekologie.xsd", "S_Ecology.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Projektressourcen.xsd", "S_Project_Resources.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Schwertransport.xsd", "S_Heavy_Transport.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Statische_Beschilderung.xsd", "S_Static_Signage.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Strassenausstattungen.xsd", "S_Road_Equipment.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Strassennetz.xsd", "S_Road_Network.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Strassenverzeichnis.xsd", "S_Road_Directory.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Strassenzustandsdaten.xsd", "S_Road_Condition_Data.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Topografie.xsd", "S_Topography.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Umfeldmessstelle.xsd", "S_Environment_Monitoring_Station.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Unfall.xsd", "S_Accident.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Verkehr.xsd", "S_Traffic.xsd"));
                tsFilenames.Add(new TranslationSubstring("S_Vermessungspunkt.xsd", "S_Triangulation_Station.xsd"));
                tsFilenames.Add(new TranslationSubstring("Schluesseltabellen.xsd", "Key_Tables.xsd"));

                string outFilename = TranslationSubstring.Apply(tsFilenames, @"E:\dev\OkstraI18N\SchemaEnglish\" + schemaName);

                List<TranslationSubstring> ts = TranslationSubstring.getOkstraTranslationSubstrings();

                StreamWriter translatedFilename = new StreamWriter(outFilename);


                List<TranslationSubstring> wrongTranslations = new List<TranslationSubstring>();
                wrongTranslations.Add(new TranslationSubstring("Statescape_Key", "State_Key"));

                wrongTranslations.Add(new TranslationSubstring("S_State_Acquisition.xsd", "S_Land_Acquisition.xsd"));
                wrongTranslations.Add(new TranslationSubstring("S_State_Register.xsd", "S_Land_Register.xsd"));
                wrongTranslations.Add(new TranslationSubstring("S_Statescape_Planning.xsd", "S_Landscape_Planning.xsd"));

                while (!reader.EndOfStream)
                {
                    var line = reader.ReadLine();

                    line = TranslationSubstring.Apply(ts, line);

                    // no fix wrong translations
                    line = TranslationSubstring.Apply(wrongTranslations, line);

                    translatedFilename.WriteLine(line);
                }

                System.Console.WriteLine("Writing " + outFilename);
                translatedFilename.Close();
            }
        }
    }
}
